#!/usr/bin/bash --noprofile 
# Why bash: because the source code is free and portable
# http://www.sunfreeware.com
## File: ctype_h.vhd
## Version: 1.0	 (March 13, 2002)
## Source: http://bear.ces.cwru.edu/vhdl
## Date: March 13, 2002 (Copyright)
## Author: Francis G. Wolff   Email: fxw12@po.cwru.edu
## Author: Michael J. Knieser Email: mjknieser@knieser.com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 1, or (at your option)
## any later version: http://www.gnu.org/licenses/gpl.html
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
#set -x

function enum_proto() {
  enum_ntypes=$((${#enum_types[@]}-1));
  enum=${enum_start}
  let eargs=( (enum_ntypes+1)**enum_nargs )
  while [ $enum -lt $eargs ]; do
    s=""; a=1; ai=1; z=0; n=0;
    while [ $a -le $enum_nargs ]; do
      let di=( (enum/ai)%(enum_ntypes+1) )
      if [ $di != 0 ]; then
        if [ $z == 1 ]; then z=2; fi
        let n=n+1; s="$s; a$a: ${enum_types[$di]}"
      else
        if [ $z == 0 ]; then z=1; fi
      fi 
      let a=a+1; let ai=( ai*(enum_ntypes+1) )
    done
    if [ $z != 2 ]; then
      echo -ne "$enum_head$s$enum_tail$enum_body" >>stdio_h.vhd

      if [ "$enum_body" != "" ]; then
        s=""; a=1;
        while [ $a -le $n ]; do
          s="$s${enum_list0}${enum_list1}a${a}${enum_list2}"
          let a=a+1
        done
        echo -ne "$s$enum_end" >>stdio_h.vhd
      fi
    fi
    let enum=enum+1
  done
}
echo -ne >stdio_h.vhd

cat <stdio_h_head.vhd >>stdio_h.vhd

enum_head="  procedure printf(format: IN string"
enum_types=( "ignored" "string" "integer" "std_logic" "std_logic_vector" "boolean" "bit" "bit_vector")
enum_tail=");\n\n"
enum_body=""
enum_nargs=2
enum_start=1
enum_proto

enum_head="  procedure scanf(format: IN string"
enum_types=( "ignored" "INOUT string" "INOUT integer" "INOUT std_logic" "INOUT std_logic_vector" "INOUT boolean" "INOUT bit" "INOUT bit_vector")
enum_tail=");\n\n"
enum_body=""
enum_nargs=1
enum_start=1
enum_proto

enum_head="  procedure fscanf(stream: INOUT text; format: IN string"
enum_types=( "ignored" "INOUT string" "INOUT integer" "INOUT std_logic" "INOUT std_logic_vector" "INOUT boolean" "INOUT bit" "INOUT bit_vector")
enum_tail=");\n\n"
enum_body=""
enum_nargs=1
enum_start=1
enum_proto

enum_head="  procedure sscanf(s: IN string; format: IN string"
enum_types=( "ignored" "INOUT string" "INOUT integer" "INOUT std_logic" "INOUT std_logic_vector" "INOUT boolean" "INOUT bit" "INOUT bit_vector")
enum_tail=");\n\n"
enum_body=""
enum_nargs=1
enum_start=1
enum_proto

echo "end stdio_h;" >>stdio_h.vhd
echo " " >>stdio_h.vhd






cat <stdio_h_tail.vhd >>stdio_h.vhd

enum_head="  procedure printf(format: IN string"
enum_types=( "ignored" "string" "integer" "std_logic" "std_logic_vector" "boolean" "bit" "bit_vector")
enum_tail=") is\n"
enum_body="    variable fi: integer:=1;\n  begin\n"
enum_list0=""
enum_list1="    sbufprintf(false, fi, printf_buffer, output, format, pf("; enum_list2="));\n"
enum_end="  end printf;\n\n"
enum_nargs=2
enum_start=1
enum_proto

enum_head="  procedure scanf(format: IN string"
enum_types=( "ignored" "INOUT string" "INOUT integer" "INOUT std_logic" "INOUT std_logic_vector" "INOUT boolean" "INOUT bit" "INOUT bit_vector")
enum_tail=") is\n"
enum_body="    variable fi: integer:=1;\n  begin\n"
enum_list0=""
enum_list1="    sbufscanf(false, fi, scanf_buffer, input, format, "; enum_list2=");\n"
enum_end="  end scanf;\n\n"
enum_nargs=1
enum_start=1
enum_proto

enum_head="  procedure fscanf(stream: INOUT text; format: IN string"
enum_types=( "ignored" "INOUT string" "INOUT integer" "INOUT std_logic" "INOUT std_logic_vector" "INOUT boolean" "INOUT bit" "INOUT bit_vector")
enum_tail=") is\n"
enum_body="    variable fi: integer:=1;\n  begin\n"
enum_list0=""
enum_list1="    sbufscanf(false, fi, fscanf_buffer, stream, format, "; enum_list2=");\n"
enum_end="  end fscanf;\n\n"
enum_nargs=1
enum_start=1
enum_proto

enum_head="  procedure sscanf(s: IN string; format: IN string"
enum_types=( "ignored" "INOUT string" "INOUT integer" "INOUT std_logic" "INOUT std_logic_vector" "INOUT boolean" "INOUT bit" "INOUT bit_vector")
enum_tail=") is\n"
enum_body="    variable W: line; variable fi: integer:=1;\n  begin\n    write(W, s);\n"
enum_list0=""
enum_list1="    sbufscanf(true, fi, W, output, format, "; enum_list2=");\n"
enum_end="    deallocate(W);\n  end sscanf;\n\n"
enum_nargs=1
enum_start=1
enum_proto

echo "end stdio_h;" >>stdio_h.vhd

